//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package org.apache.couchdb.nouveau.core;

import jakarta.ws.rs.WebApplicationException;
import jakarta.ws.rs.core.Response.Status;

public final class UpdatesOutOfOrderException extends WebApplicationException {

    public UpdatesOutOfOrderException(
            final boolean purge, final long currentSeq, final long matchSeq, final long attemptedSeq) {
        super(
                String.format(
                        "%s updates applied in the wrong order (current seq: %d, match seq: %d, attempted seq: %d)",
                        purge ? "Purge" : "Index", currentSeq, matchSeq, attemptedSeq),
                Status.CONFLICT);
    }
}
